if RequiredScript == "lib/units/player_team/teamaidamage" then
	local old_init = TeamAIDamage.init
	function TeamAIDamage:init(unit)
		old_init(self, unit)
		
		self._unit = unit
		self._char_tweak = tweak_data.character[unit:base()._tweak_table]
		local damage_tweak = self._char_tweak.damage
		
		self._HEALTH_INIT = 2 * damage_tweak.HEALTH_INIT
		
		self._HEALTH_TOTAL = self._HEALTH_INIT + self._HEALTH_BLEEDOUT_INIT
		self._HEALTH_TOTAL_PERCENT = self._HEALTH_TOTAL / 100
		self._health = self._HEALTH_INIT
		self._health_ratio = self._health / self._HEALTH_INIT
	end

    local old_original_teamaidamage_applydamage = TeamAIDamage._apply_damage
    function TeamAIDamage:_apply_damage(...)
        local damage_percent, health_subtracted = old_original_teamaidamage_applydamage(self, ...)
        local data = self._unit:brain()._logic_data
        if data then
            local my_data = data.internal_data
            if not my_data.said_hurt then
                if self._health_ratio <= 0.2 then
                    if not self:need_revive() then
                        my_data.said_hurt = true
                        self._unit:sound():say("g80x_plu", true)
                    end
                end
            end
        end
        return damage_percent, health_subtracted
    end
    local old_original_teamaidamage_regenerated = TeamAIDamage._regenerated
    function TeamAIDamage:_regenerated(...)
        local data = self._unit:brain()._logic_data
        if data then
            local my_data = data.internal_data
            if my_data.said_hurt then
                my_data.said_hurt = false
            end
        end
        return old_original_teamaidamage_regenerated(self, ...)
    end
	function TeamAIDamage:friendly_fire_hit(...)
		return
	end
end